=== debian/changelog ===
micropython (1.17+ds-1.1ubuntu2) jammy; urgency=medium

  * Honor skip test list consistently.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 10 Mar 2022 22:55:59 +0000

micropython (1.17+ds-1.1ubuntu1) jammy; urgency=medium

  * Add string_format_error to skipped tests: the output from python3.9 and
    python3.10 differs, so micropython's behavior is reasonable but no
    longer matches that of system python3.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 10 Mar 2022 21:41:12 +0000

micropython (1.17+ds-1.1) unstable; urgency=high

  * Non-maintainer upload.
  * debian/rules: Circumvent FTBFS with gcc 11 using
    -Wno-error=maybe-uninitialized cflag. (Closes: #994239)

 -- Boyuan Yang <byang@debian.org>  Wed, 10 Nov 2021 15:51:19 -0500

micropython (1.17+ds-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.6.0

 -- Yangfl <mmyangfl@gmail.com>  Sat, 04 Sep 2021 14:41:03 +0800
