=== debian/tests/control ===
Tests: unittest.sh
Depends: @builddeps@, micropython
Restrictions: allow-stderr
